
const Node = require("../structures/binary_search_tree");
class BinarySearchTree{
  constructor(vals){
    if(!Array.isArray(vals)) throw new Error("Need array please");
    this.list = vals.sort((a,b) => a - b);
    this.tree = this.buildTree(this.list, 0, this.list.length - 1);
  }
  buildTree(ary, min, max){
    if(max < min) return null;
    const mid = parseInt((min + max) / 2);
    const node = new Node(ary[mid]);
    node.left = this.buildTree(ary, min, mid-1);
    node.right = this.buildTree(ary, mid + 1, max);
    return node;
  }
  append(val){
    this.list.push(val);
    this.list.sort((a,b) => a - b);
    this.tree = this.buildTree(this.list, 0, this.list.length - 1);
    return this.tree;
  }
}

const list = [1,4,3,56,6,13,8,9];
const bst = new BinarySearchTree(list);
console.log(bst.append(7));
