//Linked List

//Values stored in *non*-contiguous memory
// - grow and change as needed
//basically a bunch of instances and pointers
//Comes in two flavors:
// - Singly linked (looks next only)
// - Doubly linked (looks next and previous)

//Downsides
// - traverse list to get to data
// - retrieval always O(n)

//This is the simplest possible linked list
class Node{
  constructor(val){
    this.value = val;
    this.next = null;
    this.previous = null
  }
  addNext(val){
    this.next = new Node(val);
    return this.next;
  }
}

//"Make me a singly-linked list"
class LinkedList{
  constructor(){
    this.head = null;
  }
  traverse(fn){
    let current = this.head;
    let last = null;
    while(current){
      const result = fn(current, last);
      last = current;
      current = current.next;
      if(result) break;
    }
    return last;
  }
  insertAt(node, val){
    const newNode = {
      value: val,
      next: node.next
    }
    node.next = newNode;
    return newNode;
  }
  append(val){
    const newNode = {
      value: val,
      next: null
    }
    if(!this.head){
      this.head = newNode;
    }else{
      //find the end of the list
      const lastNode = this.traverse(n => false);
      lastNode.next = newNode;
    }
    return newNode;
  }
  //A VERY POPULAR QUESTION
  remove(node){
    if(this.head.value === node.value){
      this.head = this.head.next;
    }else{
      this.traverse((n,last) => {
        if(n.value === node.value){
          //1 -> 2 -> 3
          last.next = n.next;
        }
      });
    }
  }
}
module.exports = LinkedList;
// const list = new LinkedList();
// const print = () => list.traverse(n => console.log(n.value));
// list.append(1);
// const two = list.append(2);
// list.append(3);
// print();
// console.log("Inserting 5...");
// list.insertAt(two, 5);
// print();
// console.log("Removing 2...");
// list.remove(two);
// print();
