//Stack
//Last In, First Out (LIFO)
//Think of a stack of plates - you always grab the one on top

//top of the stack ->> [4,3,2,1] <<- bottom of stack
//push on to top of stack
//pop off the top of stack
//peek at the top of the stack (without removing)

//no access to middle or bottom

//"Open at the top, close on the bottom"
const LinkedList = require("./linked_list");
class Stack{
  constructor(){
    this.list = new LinkedList();
    this.count = 0;
  }
  push(val){
    this.count++;
    const newNode = {
      value: val,
      next: this.list.head
    }
    this.list.head = newNode;
  }
  pop(){
    this.count--;
    const val = this.peek();
    if(val){
      this.list.remove(this.list.head);
    }
    return val;
  }
  peek(){
    return this.list.head ? this.list.head.value : null;
  }
}
module.exports = Stack;
